﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;

namespace NativeReflector
{
    /// <summary>
    /// Responsible for writing bindings to a .cs file
    /// </summary>
    public class BindingsWriter : IDisposable
    {
        private StreamWriter writer;

        private StreamWriter delegateWriter, interfaceWriter, implWriter;

        private const string ROOT_NAMESPACE = "Oxide.Ext.UE4.Bindings";
        private const string TARGET_NAMESPACE = "Oxide.Ext.UE4.Bindings.Generated";

        private IDictionary<string, ReflectedType> typeMap;

        private HashSet<int> requiredDummyStructs;
        private HashSet<string> emittedDelegates;

        private static HashSet<string> blacklistMethods = new HashSet<string>()
        {
            "GetLinker", // Just a pain in the ass function to deal with
            "Finalize", // Conflicts with C# deconstructors
            "ToString", // Conflicts with C# ToString
            "GetType" // Conflicts with C# GetType
        };

        /// <summary>
        /// Initializes a new instance of the BindingsWriter class
        /// </summary>
        /// <param name="writer"></param>
        public BindingsWriter(Stream delegateStream, Stream interfaceStream, Stream implStream)
        {
            delegateWriter = new StreamWriter(delegateStream);
            interfaceWriter = new StreamWriter(interfaceStream);
            implWriter = new StreamWriter(implStream);

            requiredDummyStructs = new HashSet<int>();
            emittedDelegates = new HashSet<string>();
        }

        private static string Tab(int tabCount)
        {
            // Assemble tab string
            char[] tabArr = new char[tabCount];
            for (int i = 0; i < tabArr.Length; i++)
                tabArr[i] = '\t';
            return new string(tabArr);
        }

        private void WriteHeader(string name, string subNamespace = null)
        {
            writer.WriteLine("/* Generated by NativeReflector */");
            writer.WriteLine($"/* {name} */");
            writer.WriteLine();
            writer.WriteLine("using System;");
            writer.WriteLine("using System.Runtime.InteropServices;");
            writer.WriteLine();
            if (ROOT_NAMESPACE != TARGET_NAMESPACE) writer.WriteLine($"using {ROOT_NAMESPACE};");
            writer.WriteLine();
            if (string.IsNullOrEmpty(subNamespace))
                writer.WriteLine($"namespace {TARGET_NAMESPACE}");
            else
                writer.WriteLine($"namespace {TARGET_NAMESPACE}.{subNamespace}");
            writer.WriteLine("{");
        }

        public void WriteHeaders()
        {
            writer = delegateWriter;
            WriteHeader("Delegates", "Delegates");

            writer = interfaceWriter;
            WriteHeader("Interfaces");

            writer = implWriter;
            WriteHeader("Implementations", "Implementations");
            writer.WriteLine($"\tusing {TARGET_NAMESPACE}.Delegates;");
        }

        public void WriteFooters()
        {
            delegateWriter.WriteLine("}");
            interfaceWriter.WriteLine("}");
            implWriter.WriteLine("}");
        }

        /// <summary>
        /// Returns if the specified type is ok to export
        /// </summary>
        /// <param name="type"></param>
        /// <returns></returns>
        private bool FilterType(ReflectedType type)
        {
            // Are all base types known?
            return type.BaseClasses.All(TypeIsKnown);
        }

        [StructLayout(LayoutKind.Sequential, Size = 8)]
        internal struct Dummy8
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] Data;
        }

        public void WriteTypeBindings(IEnumerable<ReflectedType> types)
        {
            // Build a type map
            typeMap = new Dictionary<string, ReflectedType>();
            foreach (ReflectedType type in types)
                typeMap.Add(type.Name, type);

            // Find all interfaces first
            /*foreach (ReflectedType type in types.Where(t => t.IsInterface))
            {
                // Check all base types resolve into interfaces
                if (type.BaseClasses.All(c => typeMap.ContainsKey(c.Name) && typeMap[c.Name].IsInterface))
                {
                    EmitType(type, 1);
                }
            }*/

            foreach (var type in typeMap.Values.Where(FilterType))
            {
                writer = interfaceWriter;
                EmitTypeInterface(type, 1);

                writer = implWriter;
                EmitType(type, 1);
            }

            // Export required dummy structs
            writer.WriteLine();
            foreach (int sz in requiredDummyStructs)
            {
                writer = delegateWriter;
                writer.WriteLine($"\t[StructLayout(LayoutKind.Sequential, Size = {sz})] internal struct Dummy{sz} {{ [MarshalAs(UnmanagedType.ByValArray, SizeConst = {sz})] public byte[] Data; public Dummy{sz}(byte[] data) {{ this.Data = data; }} }}");
            }
        }

        private struct MethodBindDetails : IEquatable<MethodBindDetails>
        {
            public ReflectedType OwnerType;
            public ReflectedFunction Function;
            public int OverloadIndex;
            public string DelegateName;

            public bool Equals(MethodBindDetails other)
            {
                return OverloadIndex == other.OverloadIndex
                    && Function.Name == other.Function.Name
                    && Function.Signature.ParametersMatch(other.Function.Signature, true);
            }

            public override string ToString()
            {
                return $"{Function}";
            }
        }

        private bool TypeIsKnown(ReflectedTypeRef typeRef)
        {
            if (typeRef == null) return true;
            if (typeRef.Name == "NOTYPE") return false;
            switch (typeRef.RefType)
            {
                case ReflectedTypeRefType.Primitive:
                    return true;
                case ReflectedTypeRefType.Pointer:
                    return TypeIsKnown(typeRef.BaseTypeRef);
                default:
                    ReflectedType resolvedType;
                    if (!typeMap.TryGetValue(typeRef.Name, out resolvedType)) return false;
                    return FilterType(resolvedType);
            }
        }

        private void EmitDummyType(int stackSize)
        {
            requiredDummyStructs.Add(stackSize);
            writer.Write($"Dummy{stackSize}");
        }

        private string ResolveDummyType(int stackSize)
        {
            requiredDummyStructs.Add(stackSize);
            return $"Dummy{stackSize}";
        }

        private MethodBindDetails[] SelectBindableMethods(ReflectedType type, bool includeBaseClasses = false)
        {
            List<MethodBindDetails> finalList = new List<MethodBindDetails>();
            if (includeBaseClasses)
            {
                MethodBindDetails[] tmp = SelectBindableMethods(type, false);
                for (int i = 0; i < tmp.Length; i++)
                {
                    finalList.Add(tmp[i]);
                }
                foreach (var baseClassRef in type.BaseClasses)
                {
                    ReflectedType baseClass = typeMap[baseClassRef.Name];
                    tmp = SelectBindableMethods(baseClass, true);
                    for (int i = 0; i < tmp.Length; i++)
                    {
                        if (!finalList.Any(x => x.Function.Equals(tmp[i].Function)))
                        {
                            finalList.Add(tmp[i]);
                        }
                    }
                }
            }
            else
            {
                IDictionary<string, int> overloadCount = new Dictionary<string, int>();
                finalList.AddRange(type.Methods
                    .Where(m => m.Type == ReflectedMethodType.InstanceFunction
                    && TypeIsKnown(m.Signature.ReturnType)
                    && m.Signature.Parameters.All(TypeIsKnown)
                    && m.Signature.ReturnType.RefType != ReflectedTypeRefType.Type
                    && !blacklistMethods.Contains(m.Name)
                    && !m.Name.StartsWith("_"))
                    .Select(m =>
                    {
                        MethodBindDetails bindDetails = new MethodBindDetails();
                        bindDetails.Function = m;
                        bindDetails.OwnerType = type;

                        int curOverload = 0;
                        if (!overloadCount.TryGetValue(m.Name, out curOverload)) curOverload = 0;

                        if (curOverload > 0)
                        {

                        }

                        bindDetails.OverloadIndex = curOverload++;
                        overloadCount[m.Name] = curOverload;

                        if (curOverload > 1)
                            bindDetails.DelegateName = $"{type.Name}_{m.Name}_{curOverload - 1}";
                        else
                            bindDetails.DelegateName = $"{type.Name}_{m.Name}";
                        return bindDetails;
                    })
                    .Where(b => b.OverloadIndex != -1)
                );
            }

            // Remove functions that will resolve to duplicate parameter sets
            for (int i = finalList.Count - 1; i > 0; i--)
            {
                MethodBindDetails a = finalList[i];
                string pA = string.Join(",", a.Function.Signature.ParametersNoThis.Select(p => ResolveTypeRef(p, ResolveTypeRefMethod.AsManagedParameter)));
                for (int j = i - 1; j >= 0; j--)
                {
                    MethodBindDetails b = finalList[j];
                    if (a.Function.Name == b.Function.Name)
                    {
                        string pB = string.Join(",", b.Function.Signature.ParametersNoThis.Select(p => ResolveTypeRef(p, ResolveTypeRefMethod.AsManagedParameter)));
                        if (pA == pB)
                        {
                            // We want a reason to remove a
                            if (a.Function.Signature.Parameters.Any(p => p.IsBasedUpon("wchar_t")))
                            {
                                // Remove a
                                finalList.RemoveAt(i);
                                break;
                            }
                            if (a.Function.Signature.HasThis && b.Function.Signature.HasThis)
                            {
                                if (a.Function.Signature.ReturnType.Equals(b.Function.Signature.ReturnType))
                                {
                                    if (!a.Function.Signature.Parameters.First().IsPointerTo(type.Name))
                                    {
                                        // Remove a
                                        finalList.RemoveAt(i);
                                        break;
                                    }
                                }
                                else
                                {
                                    if (!a.Function.Signature.Parameters.First().IsPointerTo(type.Name))
                                    {
                                        // Remove b
                                        finalList.RemoveAt(j);
                                        i--;
                                    }
                                }
                            }
                        }
                    }
                }
            }

            return finalList.ToArray();
        }

        private ReflectedType FindMethodOwnerFromHierachy(ReflectedType topLevel, string methodName)
        {
            // Iterate each class
            foreach (var baseClassRef in topLevel.BaseClasses)
            {
                var baseClass = typeMap[baseClassRef.Name];
                if (baseClass.Methods.Any(m => m.Name == methodName))
                    return baseClass;
                ReflectedType recursive = FindMethodOwnerFromHierachy(baseClass, methodName);
                if (recursive != null)
                    return recursive;
            }
            return null;
        }

        private void EmitTypeInterface(ReflectedType type, int tabCount)
        {
            string tabs = Tab(tabCount);

            // Emit header
            if (type.BaseClassCount > 0)
                writer.WriteLine($"{tabs}public interface {type.Name} : {string.Join(", ", type.BaseClasses)}");
            else
                writer.WriteLine($"{tabs}public interface {type.Name}");
            writer.WriteLine($"{tabs}{{");

            // Find methods we're going to bind
            MethodBindDetails[] methodsToBind = SelectBindableMethods(type);

            // Generate definitions
            for (int i = 0; i < methodsToBind.Length; i++)
            {
                string innerTab = tabs + "\t";

                MethodBindDetails bindDetails = methodsToBind[i];

                // If a base interface already defines it, ignore it
                if (FindMethodOwnerFromHierachy(type, bindDetails.Function.Name) == null)
                {

                    writer.Write(innerTab);
                    var retType = bindDetails.Function.Signature.ReturnType;
                    if (retType.RefType == ReflectedTypeRefType.Pointer && retType.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                    {
                        writer.Write(retType.BaseTypeRef.Name);
                    }
                    else
                        EmitTypeRef(retType, ResolveTypeRefMethod.AsManagedReturnType);
                    writer.Write($" {bindDetails.Function.Name}(");
                    int j = 0;
                    foreach (var arg in bindDetails.Function.Signature.Parameters.Skip(1))
                    {
                        if (j > 0) writer.Write(", ");
                        EmitTypeRef(arg, ResolveTypeRefMethod.AsManagedParameter);
                        writer.Write($" arg{j}");
                        j++;
                    }
                    writer.WriteLine(");");
                }
            }

            // Emit footer
            writer.WriteLine($"{tabs}}}");
        }

        private string EmitDelegate(MethodBindDetails bindDetails)
        {
            string dName = bindDetails.DelegateName;
            if (!emittedDelegates.Contains(dName))
            {
                emittedDelegates.Add(dName);

                var oldWriter = writer;
                writer = delegateWriter;

                writer.Write("\tinternal ");
                EmitDelegate(dName, bindDetails.Function.Signature);

                writer = oldWriter;
            }

            return dName;
        }

        private void EmitType(ReflectedType type, int tabCount)
        {
            string tabs = Tab(tabCount);

            // Emit header
            writer.WriteLine($"{tabs}public partial class {type.Name}_impl : NativeObject, {type.Name}");
            writer.WriteLine($"{tabs}{{");

            // Emit constants
            writer.WriteLine($"{tabs}\tpublic const int SIZE = {type.Size};");
            writer.WriteLine();

            // Find methods we're going to bind
            MethodBindDetails[] methodsToBind = SelectBindableMethods(type, true);

            string innerTabs = tabs + "\t";

            // Generate delegates for them
            for (int i = 0; i < methodsToBind.Length; i++)
            {
                EmitDelegate(methodsToBind[i]);
            }

            // Generate fields for them
            for (int i = 0; i < methodsToBind.Length; i++)
            {
                MethodBindDetails bindDetails = methodsToBind[i];
                writer.WriteLine($"{innerTabs}private static {bindDetails.DelegateName} {bindDetails.DelegateName}_func;");
            }
            writer.WriteLine();

            // Emit static constructor
            writer.WriteLine($"{innerTabs}static {type.Name}_impl()");
            writer.WriteLine($"{innerTabs}{{");
            for (int i = 0; i < methodsToBind.Length; i++)
            {
                MethodBindDetails bindDetails = methodsToBind[i];
                writer.WriteLine($"{innerTabs}\t{bindDetails.DelegateName}_func = AcquireFunction<{bindDetails.DelegateName}>(\"{bindDetails.Function.QualifiedName}\", {bindDetails.OverloadIndex});");
            }
            writer.WriteLine($"{innerTabs}}}");
            writer.WriteLine();

            // Emit instance constructor
            writer.WriteLine($"{innerTabs}public {type.Name}_impl(IntPtr nativePtr)");
            writer.WriteLine($"{innerTabs}\t: base(nativePtr)");
            writer.WriteLine($"{innerTabs}{{ }}");
            writer.WriteLine();

            // Emit methods
            string innerTab = tabs + "\t";
            string innerTab2 = tabs + "\t\t";
            string innerTab3 = tabs + "\t\t\t";
            for (int i = 0; i < methodsToBind.Length; i++)
            {
                MethodBindDetails bindDetails = methodsToBind[i];

                var func = bindDetails.Function;
                var sig = func.Signature;

                writer.Write(innerTab);
                EmitMethod(bindDetails.Function.Name, ReflectedMethodAccess.Public, false, sig.ReturnType, sig.Parameters.Skip(1).ToArray(), false);
                writer.WriteLine($"{innerTab}{{");

                bool hasReturnType = sig.ReturnType.Name != "void";

                // Declare holder for delegate return type
                if (hasReturnType)
                {
                    writer.Write(innerTab2);
                    EmitTypeRef(sig.ReturnType, ResolveTypeRefMethod.AsNativeVariable);
                    writer.WriteLine(" ret;");
                }

                // Start the function call
                writer.Write(innerTab2);
                if (hasReturnType) writer.Write("ret = ");
                writer.Write($"{bindDetails.DelegateName}_func(");

                // Write each arg
                writer.Write("nativePtr");
                int j = 0;
                foreach (var arg in sig.Parameters.Skip(1))
                {
                    writer.Write(", ");

                    // Is it a ptr to a known type?
                    /*if (arg.RefType == ReflectedTypeRefType.Pointer)
                    {
                        var baseTR = arg.BaseTypeRef;
                        if (baseTR.RefType == ReflectedTypeRefType.Primitive)
                        {
                            if (baseTR.Name == "void" || baseTR.Name == "char" || baseTR.Name == "wchar_t")
                                writer.Write($"arg{j}");
                            else
                                writer.Write($"ref arg{j}");
                        }
                        else if (baseTR.RefType == ReflectedTypeRefType.Type)
                        {
                            if (typeMap.ContainsKey(baseTR.Name))
                            {
                                writer.Write($"(NativePointer)(arg{j} as NativeObject)");
                            }
                            else
                            {
                                writer.Write($"arg{j}");
                            }
                        }
                        else
                        {
                            writer.Write($"arg{j}");
                        }
                    }
                    else
                    {
                        writer.Write($"arg{j}");
                    }*/

                    writer.Write(ResolveTypeAsArg(arg, $"arg{j}"));

                    j++;
                }

                // End the function call
                writer.WriteLine(");");


                // Return
                if (hasReturnType)
                {
                    // Do we need to cast?
                    if (sig.ReturnType.RefType == ReflectedTypeRefType.Pointer && sig.ReturnType.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                    {
                        writer.WriteLine($"{innerTab2}return Allocator<{sig.ReturnType.BaseTypeRef.Name}>(ret);");
                    }
                    else
                        writer.WriteLine($"{innerTab2}return ret;");
                }

                writer.WriteLine($"{innerTab}}}");
            }

            // Emit footer
            writer.WriteLine($"{tabs}}}");
            writer.WriteLine($"{tabs}");
        }

        private void EmitDelegate(string name, ReflectedFunctionSignature functionSig)
        {
            writer.Write("delegate ");
            EmitTypeRef(functionSig.ReturnType, ResolveTypeRefMethod.AsNativeReturnType);
            writer.Write($" {name}(");
            int i = 0;
            foreach (ReflectedTypeRef argType in functionSig.Parameters)
            {
                if (i > 0) writer.Write(", ");
                /*if (argType.RefType == ReflectedTypeRefType.Pointer)
                {
                    // is it a pointer to a primitive?
                    if (argType.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive && argType.BaseTypeRef.Name != "void")
                    {
                        // Ref it
                        writer.Write($"ref {argType.BaseTypeRef.NetType}");
                    }
                    else
                    {
                        writer.Write("IntPtr");
                    }
                }
                else
                {
                    EmitTypeRef(argType);
                }*/
                EmitTypeRef(argType, ResolveTypeRefMethod.AsNativeParameter);
                writer.Write($" arg{i}");
                i++;
            }
            writer.WriteLine(");");
        }

        private void EmitMethod(string name, ReflectedMethodAccess accessModifier = ReflectedMethodAccess.None, bool virt = false, ReflectedTypeRef returnType = null, ReflectedTypeRef[] args = null, bool closed = true)
        {
            switch (accessModifier)
            {
                case ReflectedMethodAccess.Public:
                    writer.Write("public ");
                    break;
                case ReflectedMethodAccess.Protected:
                    writer.Write("protected ");
                    break;
                case ReflectedMethodAccess.Private:
                    writer.Write("private ");
                    break;
            }
            if (virt) writer.Write("virtual ");
            if (returnType != null)
            {
                if (returnType.RefType == ReflectedTypeRefType.Pointer && returnType.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                {
                    writer.Write(returnType.BaseTypeRef.Name);
                }
                else
                    EmitTypeRef(returnType, ResolveTypeRefMethod.AsManagedReturnType);
            }
            else
            {
                writer.Write("void");
            }
            writer.Write(" ");
            writer.Write(name);
            writer.Write("(");
            if (args != null)
            {
                for (int i = 0; i < args.Length; i++)
                {
                    if (i > 0) writer.Write(", ");
                    EmitTypeRef(args[i], ResolveTypeRefMethod.AsManagedParameter);
                    writer.Write($" arg{i}");
                }
            }
            writer.Write(")");
            if (closed)
            {
                writer.WriteLine(";");
            }
            else
            {
                writer.WriteLine();
            }
        }

        private enum ResolveTypeRefMethod { AsNativeVariable, AsManagedVariable, AsNativeReturnType, AsManagedReturnType, AsNativeParameter, AsManagedParameter }

        private string ResolveTypeRef(ReflectedTypeRef typeRef, ResolveTypeRefMethod method)
        {
            switch (method)
            {
                case ResolveTypeRefMethod.AsNativeVariable: // It's a variable meant to hold the native version
                    switch (typeRef.RefType)
                    {
                        case ReflectedTypeRefType.Primitive:
                            return typeRef.NetType;
                        case ReflectedTypeRefType.Pointer:
                            if (typeRef.BaseTypeRef.Name == "char" || typeRef.BaseTypeRef.Name == "wchar_t")
                                return "string";
                            else
                                return "IntPtr";
                        case ReflectedTypeRefType.Function:
                            return "IntPtr";
                        default:
                            throw new NotImplementedException();
                    }

                case ResolveTypeRefMethod.AsManagedReturnType:
                case ResolveTypeRefMethod.AsManagedVariable: // It's a variable meant to hold the managed version
                    switch (typeRef.RefType)
                    {
                        case ReflectedTypeRefType.Primitive:
                            return typeRef.NetType;
                        case ReflectedTypeRefType.Pointer:
                            if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                                return typeRef.BaseTypeRef.NetType;
                            else if (typeRef.BaseTypeRef.Name == "char" || typeRef.BaseTypeRef.Name == "wchar_t")
                                return "string";
                            else
                                return "IntPtr";
                        case ReflectedTypeRefType.Function:
                            return "IntPtr";
                        default:
                            throw new NotImplementedException();
                    }

                case ResolveTypeRefMethod.AsNativeReturnType:

                    switch (typeRef.RefType)
                    {
                        case ReflectedTypeRefType.Primitive:
                            return typeRef.NetType;
                        case ReflectedTypeRefType.Pointer:
                            if (typeRef.BaseTypeRef.Name == "char" || typeRef.BaseTypeRef.Name == "wchar_t")
                                return "string";
                            else
                                return "IntPtr";
                        case ReflectedTypeRefType.Function:
                            return "IntPtr";
                        default:
                            throw new NotImplementedException();
                    }


                case ResolveTypeRefMethod.AsManagedParameter:

                    switch (typeRef.RefType)
                    {
                        case ReflectedTypeRefType.Primitive:
                            return typeRef.NetType;
                        case ReflectedTypeRefType.Pointer:
                            if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                                return typeRef.BaseTypeRef.NetType;
                            else if (typeRef.BaseTypeRef.Name == "char" || typeRef.BaseTypeRef.Name == "wchar_t")
                                return "string";
                            else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive && typeRef.BaseTypeRef.NetType != "void")
                                return $"ref {typeRef.BaseTypeRef.NetType}";
                            else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer && typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer)
                                return "ref IntPtr";
                            else
                                return "IntPtr";
                        case ReflectedTypeRefType.Function:
                            return "IntPtr";
                        case ReflectedTypeRefType.Type:
                            return typeRef.NetType;
                        default:
                            throw new NotImplementedException();
                    }

                case ResolveTypeRefMethod.AsNativeParameter:

                    switch (typeRef.RefType)
                    {
                        case ReflectedTypeRefType.Primitive:
                            return typeRef.NetType;
                        case ReflectedTypeRefType.Pointer:
                            if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                                return "IntPtr";
                            else if (typeRef.BaseTypeRef.Name == "char")
                                return "[MarshalAs(UnmanagedType.LPStr)] string";
                            else if (typeRef.BaseTypeRef.Name == "wchar_t")
                                return "[MarshalAs(UnmanagedType.LPWStr)] string";
                            else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive && typeRef.BaseTypeRef.NetType != "void")
                                return $"ref {typeRef.BaseTypeRef.NetType}";
                            else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer && typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer)
                                return "ref IntPtr";
                            else
                                return "IntPtr";
                        case ReflectedTypeRefType.Function:
                            return "IntPtr";
                        case ReflectedTypeRefType.Type:
                            if (TypeIsKnown(typeRef))
                                return ResolveDummyType(typeMap[typeRef.NetType].Size);
                            else
                                throw new NotImplementedException();
                        default:
                            throw new NotImplementedException();
                    }
                default:
                    throw new NotImplementedException();
            }

            /*if (typeRef == null)
            {
                return "void";
            }
            if (typeRef.RefType == ReflectedTypeRefType.Pointer)
            {
                if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                {
                    if (resolveNetTypePtr)
                        return typeRef.BaseTypeRef.NetType;
                    else
                        return typeRef.NetType;
                }
                else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive)
                {
                    if (typeRef.BaseTypeRef.Name == "char")
                    {
                        if (emitMarshal)
                            return "[MarshalAs(UnmanagedType.LPStr)] string";
                        else
                            return "string";
                    }
                    if (typeRef.BaseTypeRef.Name == "wchar_t")
                    {
                        if (emitMarshal)
                            return "[MarshalAs(UnmanagedType.LPWStr)] string";
                        else
                            return "string";
                    }
                    else if (resolveNetTypePtr)
                    {
                        if (typeRef.BaseTypeRef.Name == "void")
                            return typeRef.NetType;
                        else
                            return $"ref {typeRef.BaseTypeRef.NetType}";
                    }
                    else
                    {
                        if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive && typeRef.BaseTypeRef.NetType != "void")
                        {
                            return $"ref {typeRef.BaseTypeRef.NetType}";
                        }
                        else
                        {
                            return typeRef.NetType;
                        }
                    }
                }
                else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer)
                {
                    if (resolveNetTypePtr && typeRef.BaseTypeRef.Name != "void")
                    {
                        return $"ref {typeRef.BaseTypeRef.NetType}";
                    }
                    else
                    {
                        return typeRef.NetType;
                    }
                }
                else
                {
                    return typeRef.NetType;
                }
            }
            else
            {
                return typeRef.NetType;
            }*/
        }

        private string ResolveTypeAsArg(ReflectedTypeRef typeRef, string valRef)
        {
            switch (typeRef.RefType)
            {
                case ReflectedTypeRefType.Primitive:
                    // primitive to primitive
                    return valRef;
                case ReflectedTypeRefType.Pointer:
                    // ref, NativeObject or IntPtr to pointer
                    if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Type)
                        return $"(NativePointer)({valRef} as NativeObject)";
                    else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Primitive
                            && typeRef.BaseTypeRef.NetType != "void"
                            && typeRef.BaseTypeRef.NetType != "char"
                            && typeRef.BaseTypeRef.NetType != "wchar_t")
                        return $"ref {valRef}";
                    else if (typeRef.BaseTypeRef.RefType == ReflectedTypeRefType.Pointer)
                        return $"ref {valRef}";
                    else
                        return valRef;
                case ReflectedTypeRefType.Type:
                    // NativeObject to value-type (Dummy struct)
                    if (!TypeIsKnown(typeRef)) throw new NotImplementedException();
                    var rType = typeMap[typeRef.Name];
                    return $"new Dummy{rType.Size}(({valRef} as NativeObject).GetRawData({rType.Size}))";
                default:
                    throw new NotImplementedException();
            }
        }

        private void EmitTypeRef(ReflectedTypeRef typeRef, ResolveTypeRefMethod method)
        {
            writer.Write(ResolveTypeRef(typeRef, method));
        }

        #region IDisposable Support

        private bool disposedValue = false; // To detect redundant calls

        protected virtual void Dispose(bool disposing)
        {
            if (!disposedValue)
            {
                if (disposing)
                {
                    delegateWriter.Dispose();
                    delegateWriter = null;

                    interfaceWriter.Dispose();
                    interfaceWriter = null;

                    implWriter.Dispose();
                    implWriter = null;

                    writer = null;
                }

                // TODO: free unmanaged resources (unmanaged objects) and override a finalizer below.
                // TODO: set large fields to null.

                disposedValue = true;
            }
        }

        // TODO: override a finalizer only if Dispose(bool disposing) above has code to free unmanaged resources.
        // ~BindingsWriter() {
        //   // Do not change this code. Put cleanup code in Dispose(bool disposing) above.
        //   Dispose(false);
        // }

        // This code added to correctly implement the disposable pattern.
        public void Dispose()
        {
            // Do not change this code. Put cleanup code in Dispose(bool disposing) above.
            Dispose(true);
            // TODO: uncomment the following line if the finalizer is overridden above.
            // GC.SuppressFinalize(this);
        }

        #endregion
    }
}
